#include "graficas.h"

/* Funcin que inicia el entorno grfico detectando de manera automtica
la tarjeta grfica y el modo de trabajo */
void Iniciar(void) {
int driver, modo;

  detectgraph(&driver, &modo);
  initgraph(&driver, &modo, "c:\progra~1\bc31\bgi");
}

/* Funcin que dibuja el eje horizontal y vertical del diagrama de Gantt as
como los ejes horizontales para cada una de las mquinas. La funcin devuelve
la parte de pantalla vertical que le corresponde a cada mquina. */
void Ejes(int maquinas, char *limite) {
int x1, x2, y;
register int i, j;
char num[1];

  tmax = atoi(limite); 			/* tiempo maximo de proceso */
  unidad =(float) (getmaxx() - (M_DER + M_IZQ)) / tmax;  /* pixels por unidad de tiempo */
  vertical = (float)(getmaxy() - M_INF) / maquinas;
  x1 = M_IZQ;
  x2 = getmaxx() - M_DER;
  y = maquinas * vertical;

  /* eje horizontal de cada mquina */
  for (i = 1; i < maquinas; i++)
    line(x1, (vertical * i), x2, (vertical * i));

  /* ejes principales */
  line(x1, 0, x1, y);
  line(x1, y, x2, y);

  /* ponemos el 0 y el limite en el eje horizontal inferior */
  outtextxy(x1-4, y + TEXT + 1, "0");
  line(x1, y, x1, y + TEXT);
  line(x2, y, x2, y + TEXT);

  /* ponemos las mquinas */
  for (i = j = 1; i < 2 * maquinas; i+= 2, j++) {
    outtextxy(x1/2, i * vertical/2, "M");
    itos(j, num);
    outtextxy(x1/2+8, i * vertical/2, num);
  }
}

/* Funcin que pone un trabajo en una mquina entre los tiempos t_ini (inicial)
y t_fin (final). Cada mquina tiene un espacio para dibujar esp */
void Pon_trabajo(int trabajo, int maquina, int t_ini, int t_fin) {
int altura;	/* altura de los rectangulos */
int pos_ini;	/* posicion inicial del trabajo en el eje X */
int alt; 	/* altura del trabajo dentro de la mquina */
char t[5];
int t1, t2;	/* posicion en pixels de t_ini y t_fin respectivamente */
float desp;	/* desplazamiento para escribir los tiempos en la barra
		   dependiendo del n de digitos del numero */

  pos_ini = maquina * vertical;
  altura = 3 * vertical / 4;
  alt = pos_ini - altura;

  /* calculamos en pixel los tiempos iniciales y finales */
  t1 = M_IZQ + unidad * t_ini;
  t2 = M_IZQ + unidad *t_fin;

  setcolor(trabajo);
  if ((trabajo % 16) == 0) /* para evitar el color negro del fondo que es 16 */
    setcolor(8);
  rectangle(t1+1, alt, t2, pos_ini-1);
  itos(trabajo, t);
  /* ponemos el numero del trabajo en medio */
  outtextxy((t2+t1) / 2, (alt + pos_ini) / 2, t);

  /* ponemos el tiempo inicial y final en la barra */
  setcolor(15);
  if (t_ini != 0) {
    itos(t_ini, t);
    desp = strlen(t) * 7;
    desp /= 2;
    outtextxy(t1-desp, pos_ini + TEXT + 1, t);
    line(t1, pos_ini, t1, pos_ini + TEXT);
  }
  itos(t_fin, t);
  desp = strlen(t) * 7;
  desp /= 2;
  outtextxy(t2-desp, pos_ini + TEXT + 1, t);
  line(t2, pos_ini, t2, pos_ini + TEXT);
}